
#ifndef BRANCHING_HPP
#define BRANCHING_HPP

namespace scaffold { namespace solv {
    enum BranchType { DeleteBranch, TakeBranch };

    struct Branch {
      const BranchType btype;
      std::list<ScafVertexPair> edges;

      Branch(const BranchType& t) : btype(t) {}
      Branch(const BranchType& t, const ScafVertexPair& p) : btype(t), edges(1, p) {}
      Branch(const BranchType& t, const ScafEdge& e, const RawScaffoldGraph& g) : btype(t), edges(1, ScafVertexPair(source(e, g), target(e,g))) {}
    };

  }// namespace

  typedef std::pair<solv::Branch&, RawScaffoldGraph&> BranchAndGraph;
  std::ostream& operator<<(std::ostream& os, const BranchAndGraph& b){
    switch(b.first.btype){
      case scaffold::solv::DeleteBranch:
        os << "Dele:";
        break;
      case scaffold::solv::TakeBranch:
        os << "Take:";
        break;
    } // switch
    return os << VertexPairListAndGraph<RawScaffoldGraph>(b.first.edges,b.second);
  }


}};

#endif

