
#pragma once

#include "utils/distributions.hpp"

namespace scaffold {

  struct JumpStatistics{
    NormalDistribution<> jump_network_sizes;
    NormalDistribution<> num_reasons_for_jump;
  };

  struct LinearizationStatistics {
    unsigned nb_cuts;
    unsigned weight_cut;
  };

  struct CallbackStatistics {
    unsigned cuts_added;
    unsigned times_called;
    double root_relax;
    timer time_spent;

    CallbackStatistics(): cuts_added(0), times_called(0) {};
  };

}

